// Code generated by running "go generate" in golang.org/x/text. DO NOT EDIT.

package main

import (
	"golang.org/x/text/language"
	"golang.org/x/text/message"
	"golang.org/x/text/message/catalog"
)

type dictionary struct {
	index []uint32
	data  string
}

func (d *dictionary) Lookup(key string) (data string, ok bool) {
	p, ok := messageKeyToIndex[key]
	if !ok {
		return "", false
	}
	start, end := d.index[p], d.index[p+1]
	if start == end {
		return "", false
	}
	return d.data[start:end], true
}

func init() {
	dict := map[string]catalog.Dictionary{
		"en": &dictionary{index: enIndex, data: enData},
		"ru": &dictionary{index: ruIndex, data: ruData},
	}
	fallback := language.MustParse("en")
	cat, err := catalog.NewFromMap(dict, catalog.Fallback(fallback))
	if err != nil {
		panic(err)
	}
	message.DefaultCatalog = cat
}

var messageKeyToIndex = map[string]int{
	"Allow":                 4,
	"Authorize %s":          0,
	"Authorize application": 1,
	"Choose your scopes":    2,
	"Deny":                  3,
	"Error":                 6,
	"How do I fix it?":      7,
	"Recipient":             10,
	"Resource":              11,
	"Send":                  12,
	"Sign In":               8,
	"TicketAuth":            9,
	"version":               5,
}

var enIndex = []uint32{ // 14 elements
	0x00000000, 0x00000010, 0x00000026, 0x00000039,
	0x0000003e, 0x00000044, 0x0000004c, 0x00000052,
	0x00000063, 0x0000006b, 0x00000076, 0x00000080,
	0x00000089, 0x0000008e,
} // Size: 80 bytes

const enData string = "" + // Size: 142 bytes
	"\x02Authorize %[1]s\x02Authorize application\x02Choose your scopes\x02De" +
	"ny\x02Allow\x02version\x02Error\x02How do I fix it?\x02Sign In\x02Ticket" +
	"Auth\x02Recipient\x02Resource\x02Send"

var ruIndex = []uint32{ // 14 elements
	0x00000000, 0x0000001f, 0x0000004d, 0x0000008e,
	0x0000009f, 0x000000b2, 0x000000bf, 0x000000cc,
	0x000000ee, 0x000000f9, 0x00000104, 0x00000119,
	0x00000126, 0x00000139,
} // Size: 80 bytes

const ruData string = "" + // Size: 313 bytes
	"\x02Авторизовать %[1]s\x02Авторизовать приложение\x02Выбери предоставляе" +
	"мые разрешения\x02Отказать\x02Разрешить\x02версия\x02Ошибка\x02Как испр" +
	"авить это?\x02Войти\x02TicketAuth\x02Получатель\x02Ресурс\x02Отправить"

	// Total table size 615 bytes (0KiB); checksum: 66FB60EC
